﻿using System;
using System.Collections.Generic;
using System.Linq;
using System.Text;
using System.Threading.Tasks;

namespace AmicablePairAndPerfectNumber
{
    /// <summary>
    /// 直接计算约数之和(并行)
    /// </summary>
    public class Algorithm2
    {
        private int GetSum(int num)
        {
            int sum = 1;
            int limit = (int)Math.Sqrt(num);
            for (int i = 2; i <= limit; i++)
                if (num % i == 0) sum += i + num / i;
            return sum;
        }

        public void Run(int from, int to)
        {
            int perfertCount = 0;
            int amicablePairCount = 0;
            Parallel.For(from, to, num =>
            {
                int sum1 = this.GetSum(num);
                if (sum1 == num)
                {
                    Console.WriteLine("{0}是完全数", num);
                    perfertCount++;
                }
                if (sum1 > num)
                {
                    int sum2 = this.GetSum(sum1);
                    if (sum2 == num)
                    {
                        Console.WriteLine("{0}和{1}是一对相亲数", sum1, sum2);
                        amicablePairCount++;
                    }
                }
            });
            Console.WriteLine("在{0}到{1}中共有{2}个完全数和{3}对相亲数", from, to, perfertCount, amicablePairCount);
        }
    }
}
