﻿using System;
using System.Collections.Generic;
using System.Linq;
using System.Text;

namespace AmicablePairAndPerfectNumber
{
    /// <summary>
    /// 通过计算所有质因数来计算约数之和（串行）
    /// </summary>
    public class Algorithm3
    {
        private int GetNextFactor(int num)
        {
            int limit = (int)(Math.Sqrt(num));
            for (int i = 2; i <= limit; i++)
                if (num % i == 0)
                    return i;
            return num;
        }

        private List<int> Decomposition(int num)
        {
            var factors = new List<int>();
            while (true)
            {
                var divisor = GetNextFactor(num);
                factors.Add(divisor);
                if (divisor == num) break;
                num = num / divisor;
            }
            return factors;
        }

        private int Sum(List<int> divisors)
        {
            int sum = 0;
            for (int i = 0, count = divisors.Count - 1; i < count; i++)
                sum += divisors[i];
            return sum;
        }

        private int GetSum(List<int> factors)
        {
            if (factors.Count == 1) return 1;//质数
            var divisors = new List<int>() { 1 };
            var factorPows = new List<List<int>>() { new List<int>() { factors[0] } };
            for (int i = 1, count = factors.Count; i < count; i++)
            {
                var length = factorPows.Count;
                if (factors[i] == factorPows[length - 1][0])
                    factorPows[length - 1].Add(Convert.ToInt32(Math.Pow(Convert.ToDouble(factors[i]), Convert.ToDouble(factorPows[length - 1].Count + 1))));
                else
                    factorPows.Add(new List<int>() { factors[i] });
            }
            for (int f = 0, fCount = factorPows.Count; f < fCount; f++)
                for (int d = 0, dCount = divisors.Count; d < dCount; d++)
                    for (int p = 0, pCount = factorPows[f].Count; p < pCount; p++)
                        divisors.Add(divisors[d] * factorPows[f][p]);
            return Sum(divisors);
        }

        public void Run(int from, int to)
        {
            int perfertCount = 0;
            int amicablePairCount = 0;
            for (var num = from; num < to; num++)
            {
                int sum1 = this.GetSum(Decomposition(num));
                if (sum1 == num)
                {
                    Console.WriteLine("{0}是完全数", num);
                    perfertCount++;
                }
                if (sum1 > num)
                {
                    int sum2 = this.GetSum(Decomposition(sum1));
                    if (sum2 == num)
                    {
                        Console.WriteLine("{0}和{1}是一对相亲数", sum1, sum2);
                        amicablePairCount++;
                    }
                }
            }
            Console.WriteLine("在{0}到{1}中共有{2}个完全数和{3}对相亲数", from, to, perfertCount, amicablePairCount);
        }
    }
}
