﻿using System;
using System.Collections.Generic;
using System.Linq;
using System.Text;

namespace AmicablePairAndPerfectNumber
{
    /// <summary>
    /// 通过计算所有质因数来计算约数之和（空间算法）
    /// </summary>
    public class Algorithm5
    {
        public List<int> primeList = new List<int>();

        public int[] firstFactorList;

        public int[] remainingList;

        public int[] resultList;

        public int GetNextFactor(int num)
        {
            var max = (int)Math.Sqrt(num);
            for (int i = 0; i < primeList.Count; i++)
            {
                var p = primeList[i];
                if (p > max) break;
                if (num % p == 0)
                    return p;
            }
            primeList.Add(num);
            return num;
        }

        public List<int> Decomposition(int num)
        {
            var divisors = new List<int>();
            var factor = firstFactorList[num] = GetNextFactor(num);
            if (factor == num)
                remainingList[num] = 1;
            else
                remainingList[num] = num / firstFactorList[num];
            while (true)
            {
                divisors.Add(firstFactorList[num]);
                if (remainingList[num] == 1) break;
                num = remainingList[num];
            }
            return divisors;
        }

        private int Sum(List<int> divisors)
        {
            int sum = 0;
            for (int i = 0, count = divisors.Count - 1; i < count; i++)
                sum += divisors[i];
            return sum;
        }

        public int GetSum(List<int> factors)
        {
            if (factors.Count == 1) return 1;//质数
            var divisors = new List<int>() { 1 };
            var factorPows = new List<List<int>>() { new List<int>() { factors[0] } };
            for (int i = 1, count = factors.Count; i < count; i++)
            {
                var length = factorPows.Count;
                if (factors[i] == factorPows[length - 1][0])
                    factorPows[length - 1].Add(Convert.ToInt32(Math.Pow(Convert.ToDouble(factors[i]), Convert.ToDouble(factorPows[length - 1].Count + 1))));
                else
                    factorPows.Add(new List<int>() { factors[i] });
            }
            for (int f = 0, fCount = factorPows.Count; f < fCount; f++)
                for (int d = 0, dCount = divisors.Count; d < dCount; d++)
                    for (int p = 0, pCount = factorPows[f].Count; p < pCount; p++)
                        divisors.Add(divisors[d] * factorPows[f][p]);
            return Sum(divisors);
        }

        public void Run(int limit)
        {
            firstFactorList = new int[limit];
            remainingList = new int[limit];
            resultList = new int[limit];
            int perfertCount = 0;
            int amicablePairCount = 0;
            for (var num = 2; num < limit; num++)
            {
                var result = resultList[num] = this.GetSum(Decomposition(num));
                if (result == num)
                {
                    Console.WriteLine("{0}是完全数", num);
                    perfertCount++;
                }
                else if (result < num && resultList[result] == num)
                {
                    Console.WriteLine("{0}和{1}是一对相亲数", result, num);
                    amicablePairCount++;
                }
            }
            Console.WriteLine("在{0}到{1}中至少有{2}个完全数和{3}对相亲数", 2, limit, perfertCount, amicablePairCount);
        }
    }
}
