﻿using System;
using System.Collections.Generic;
using System.Linq;
using System.Text;

namespace AmicablePairAndPerfectNumber
{
    /// <summary>
    /// 部分分解不求和的空间算法
    /// </summary>
    public class Algorithm6
    {
        public List<int> primeList = new List<int>();

        public int[] firstFactorList;

        public int[] remainingList;

        public int[] resultList;

        public int GetNextFactor(int num)
        {
            var max = (int)Math.Sqrt(num);
            for (int i = 0; i < primeList.Count; i++)
            {
                var p = primeList[i];
                if (p > max) break;
                if (num % p == 0)
                    return p;
            }
            primeList.Add(num);
            return num;
        }

        public int GetSum(int num)
        {
            var factor = firstFactorList[num] = GetNextFactor(num);
            if (factor == num)
            {
                remainingList[num] = 1;
                return 1;
            }
            else
            {
                remainingList[num] = num / firstFactorList[num];
                var r = remainingList[num];
                while (r % factor == 0)
                    r = r / factor;
                return (resultList[remainingList[num]] + remainingList[num]) * factor + (resultList[r] + r) - num;
            }
        }

        public void Run(int limit)
        {
            firstFactorList = new int[limit];
            remainingList = new int[limit];
            resultList = new int[limit];
            int perfertCount = 0;
            int amicablePairCount = 0;
            for (var num = 2; num < limit; num++)
            {
                var result = resultList[num] = this.GetSum(num);
                if (result == num)
                {
                    Console.WriteLine("{0}是完全数", num);
                    perfertCount++;
                }
                else if (result < num && resultList[result] == num)
                {
                    Console.WriteLine("{0}和{1}是一对相亲数", result, num);
                    amicablePairCount++;
                }
            }
            Console.WriteLine("在{0}到{1}中至少有{2}个完全数和{3}对相亲数", 2, limit, perfertCount, amicablePairCount);
        }
    }
}
